activities/urls.py
from django.urls import include, path

from activities.views import (
    ActivityDetailsView,
    ActivityEnrollmentSuccessView,
    ActivityUnrollmentSuccessView,
    IndexView,
    enroll,
    unroll,
)

app_name = "activities"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("<int:pk>", ActivityDetailsView.as_view(), name="detail"),
    path("inschrijvingen/<int:admittanceID>/inschrijven", enroll, name="enroll"),
    path(
        "inschrijvingen/<int:pk>/inschrijving_gelukt",
        ActivityEnrollmentSuccessView.as_view(),
        name="enroll_success",
    ),
    path("inschrijvingen/<int:admittanceID>/uitschrijven", unroll, name="unroll"),
    path(
        "inschrijvingen/<int:pk>/uitschrijving_gelukt",
        ActivityUnrollmentSuccessView.as_view(),
        name="unroll_success",
    ),
]

groups/urls.py
from django.urls import path

from . import views

app_name = "groups"
urlpatterns = [
    path("", views.GroupListView.as_view(), name="groups"),
    path("<int:pk>/", views.GroupDetailView.as_view(), name="group_detail"),
    path(
        "lid/<int:pk>", views.GroupMembershipDetailView.as_view(), name="member_detail"
    ),
    path(
        "categorie/<int:pk>/",
        views.GroupCategoryDetailView.as_view(),
        name="cat_detail",
    ),
]

news/urls.py
from django.urls import path

from . import views

app_name = "news"
urlpatterns = [
    path("", views.NewsListView.as_view(), name="news_list"),
    path("<int:pk>/", views.NewsDetailView.as_view(), name="news_detail"),
]

unchained/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.generic import RedirectView, TemplateView

from wrinklypages import views as wpviews

from . import views

urlpatterns = [
    path("", RedirectView.as_view(pattern_name="home")),
    path("home/", views.index, name="home"),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path("admin/", admin.site.urls),
    path("activiteiten/", include("activities.urls")),
    path("service/docuweb/", include("docuweb.urls")),
    path("pages/", include("django.contrib.flatpages.urls")),
    path("leden/", include("members.urls")),
    path("vereniging/nieuws/", include("news.urls")),
    path("accounts/", include("authentication.urls")),
    path("vereniging/commissies/", include("groups.urls")),
    path("achievements/", include("achievements.urls")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ideal/", include("ideal.urls")),
    path("carriere/", include("career.urls")),
    path("publisher/", include("wrinklypages.urls")),
    path("tinymce/", include("tinymce.urls")),
    path("__debug__/", include("debug_toolbar.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

groups/models.py
import datetime
from typing import Dict, Optional

import django.utils.timezone as timezone
from django.conf import settings
from django.conf.urls.static import static
from django.db import models

from authentication.models import AuthGroup
from members.models.person import Person
from unchained.junk_drawer import enum_field
from unchained.types.queryset import QueryType

# TODO: Maybe make this relative or dynamic instead of hardcoded?
# TODO: Exposing Person from the members app to the root module doesn't seem to work, AppRegistryNotReady error if I put this in __init__.py of the members app:
# Apparently its impossible to import models or other subpackages in the root package of an application. Maybe we should find a workaround, as it would come in handy if different
# apps can only access exposed models etc.


class GroupCategory(models.Model):
    """Different types of groups."""

    title: str = models.CharField(max_length=256)

    def __str__(self) -> str:
        return self.title


class Group(models.Model):
    """Various kinds of groups of people."""

    COMMITTEE: str = "committee"
    GROUP: str = "group"
    SOCIETY: str = "SOCIETY"
    KIND: Dict[str, str] = {COMMITTEE: "committee", GROUP: "group", SOCIETY: "society"}
    KIND_NL: Dict[str, str] = {
        COMMITTEE: "commissie",
        GROUP: "groep",
        SOCIETY: "dispuut",
    }

    name: str = models.CharField(max_length=32)
    description: str = models.TextField(max_length=128, blank=True, null=True)
    email: str = models.CharField(max_length=64, blank=True, null=True)

    kind: str = enum_field(KIND, default=COMMITTEE)
    since: datetime = models.DateField(default=timezone.now)
    until: datetime = models.DateField(blank=True, null=True)
    poster = models.ImageField(upload_to="posters/groups", null=True, blank=True)
    website = models.CharField(max_length=64, blank=True, null=True)

    auth_groups: QueryType[AuthGroup] = models.ManyToManyField(AuthGroup, blank=True)

    members: QueryType[Person] = models.ManyToManyField(
        Person, through="GroupMembership"
    )

    categories: Optional[GroupCategory] = models.ForeignKey(
        GroupCategory, on_delete=models.PROTECT, blank=True, null=True
    )

    def __str__(self) -> str:
        return f"{self.name}"

    def get_poster_url(self):
        if self.poster:
            return self.poster.url
        else:
            return settings.MEDIA_URL + "posters/groups/defaultposter.jpg"


class GroupMembership(models.Model):
    """Records that a Contact is a member of a group."""

    person: Person = models.ForeignKey(Person, on_delete=models.CASCADE)
    group: Group = models.ForeignKey(Group, on_delete=models.CASCADE)

    since: datetime = models.DateField(default=timezone.now)
    until: datetime = models.DateField(blank=True, null=True)

    def __str__(self):
        return f"{self.person} is a member of {self.group}"

achievements/views/detailviews.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views import generic

from achievements.rewarding.achievement_utilities import person_has_achievement
from members.models.person import Person

from ..models import Achieved, Achievement, Medal, Received


class AchievementDetailView(LoginRequiredMixin, generic.DetailView):
    """
    this page shows in detail information about a specific achievement

    **authorised user only**

    **CONTEXT:**

        ``user_sees_achievement``
            bool which determines whether or not the current user has the rights to see this achievement

        ``achiever-list``
            a list of all people who have achieved this achievement

        ``num_visits``
            the number of times the current session has visited this specific achievement page in a row
            used for bad achievement lookup surprise

    **SESSION_DATA:**

        ``ACHIEVEMENTS_last_visited_achievement``
            abbrev field of the last visited achievement page,
            used to check if the current page is the same as the last page visited (used for surprise)

        ``ACHIEVEMENTS_num_visits``
            int telling how many times in a row this page has been visited by the current session

    **TEMPLATES:**

        :template:`../achievements/templates/achievements/achievement_detail.html`
    """

    model = Achievement

    slug_field = "abbrev"
    slug_url_kwarg = "name"

    def get_context_data(self, **kwargs):
        if (
            self.request.session.get("ACHIEVEMENTS_last_visited_achievement", "")
            == self.object.abbrev
        ):
            num_visits = self.request.session.get("ACHIEVEMENTS_num_visits", 0) + 1
        else:
            num_visits = 1
        self.request.session[
            "ACHIEVEMENTS_last_visited_achievement"
        ] = self.object.abbrev
        self.request.session["ACHIEVEMENTS_num_visits"] = num_visits
        user = self.request.user
        user_sees_achievement = (
            self.object.hidden
            or user.has_perm("achievements.can_see_all")
            or person_has_achievement(user.person, self.object)
        )

        context = super(AchievementDetailView, self).get_context_data(**kwargs)
        context["user_sees_achievement"] = user_sees_achievement
        context["achiever_list"] = Achieved.objects.filter(
            achievement=self.object
        ).filter(has_achieved=True)
        context["num_visits"] = num_visits
        # NOTE:
        #       type(user_sees_achievement)==Boolean
        #       type(achiever_list)==Queryset
        #       type(num_visits)==Integer
        return context


class MedalDetailView(LoginRequiredMixin, generic.DetailView):
    """
    This page shows detailed information about this :model:`achievements.medal`

    **authorised user only**

    **CONTEXT:**

        ``bronze_receiver_list``
            A list\* of all people who have the bronze rank in this medal

        ``silver_receiver_list``
            A list\* of all people who have the silver rank in this medal

        ``gold_receiver_list``
            A list\* of all people who have the gold rank in this medal

        ``platinum_receiver_list``
            A list\* of all people who have the platinum rank in this medal

        \* actually a queryset, but who cares amirite?
    **TEMPLATES:**
        :template:`../achievements/templates/achievements/medal_detail.html
    """

    model = Medal

    slug_field = "abbrev"
    slug_url_kwarg = "name"

    def get_context_data(self, *args, **kwargs):
        context = super(MedalDetailView, self).get_context_data(*args, **kwargs)
        context["bronze_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=1)
        context["silver_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=2)
        context["gold_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=3)
        context["platinum_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=4)
        return context

groups/views.py
from django.db.models import Q
from django.shortcuts import render
from django.template.defaulttags import register
from django.urls import reverse
from django.utils import timezone
from django.utils.html import format_html
from django.views import generic

from activities.models import Event

from .models import Group, GroupCategory, GroupMembership


@register.filter
def enum_name(key, names):
    return names.get(key, key)


@register.simple_tag
def group_link(group):
    return format_html(
        '<a href="{}">{}</a>',
        reverse("groups:group_detail", args=[group.id]),
        group.name,
    )


@register.simple_tag
def group_member_link(member):
    return format_html(
        '<a href="{}">{}</a>',
        reverse("members:detail", args=[member.person.id]),
        member.person,
    )


@register.simple_tag
def group_category_link(cat):
    return format_html(
        '<a href="{}">{}</a>', reverse("groups:cat_detail", args=[cat.id]), cat.title
    )


class GroupDetailView(generic.DetailView):
    model = Group
    template_name = "groups/detail.html"
    context_object_name = "group"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        group = context["group"]
        activities = group.activity_set.all()
        events = Event.objects.filter(activity__in=activities)
        curr_time = timezone.now()
        context["events_upcoming"] = events.filter(time_end__gt=curr_time)
        context["events_past"] = events.filter(time_end__lte=curr_time)
        related_groups = Group.objects.filter(categories=group.categories).exclude(
            id=group.pk
        )
        context["related"] = related_groups
        members = group.groupmembership_set
        context["members_current"] = members.filter(
            Q(until__isnull=True) | Q(until__gte=curr_time)
        )
        context["members_past"] = members.filter(
            Q(until__isnull=False) & Q(until__lt=curr_time)
        )
        return context


class GroupCategoryDetailView(generic.DetailView):
    model = GroupCategory
    template_name = "groups/cat_detail.html"


class GroupMembershipDetailView(generic.DetailView):
    model = GroupMembership
    template_name = "groups/member_detail.html"


class GroupListView(generic.ListView):
    model = Group
    template_name = "groups/group_list.html"

    def get(self, request, *args, **kwargs):
        committees = Group.objects.filter(kind=Group.COMMITTEE)
        groups = Group.objects.filter(kind=Group.GROUP)
        societies = Group.objects.filter(kind=Group.SOCIETY)

        return render(
            request,
            self.template_name,
            {
                "committees": committees,
                "groups": groups,
                "societies": societies,
            },
        )

groups/templates/groups/cat_detail.html
{% extends "base.html" %}
{% load i18n %}

{% block body %}
<h1>{% trans "Groepcategorie" %}</h1>
<p>{% trans "Titel: " %}{{ groupcategory.title }}</p>
<br>
<h1>{% trans "Groepen" %}</h1>
<ul>
    {% for group in groupcategory.group_set.all %}
        <li>{% group_link group %}</li>
    {% endfor %}
</ul>
{% endblock %}

groups/templates/groups/detail.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}

{% block title %} {{ group.name }} {% endblock %}

{% block banner %}
    <div class="is-size-1 group-underline">
        <div class="box mb-1 mt-0 birthdays-buttons has-background-primary has-text-white">
            {{ group.name }}
        </div>
    </div>
    <div class="tabs is-toggle is-centered is-medium mt-4">
        <ul>
            <li class="js-tab is-active"><a class="box mx-4 is-capitalized">{{ group.kind|enum_name:group.KIND_NL }}-{% trans "informatie" %}</a></li>
            <li class="js-tab"><a class="box mx-4">Leden</a></li>
            {% if group.activity_set.exists %}
            <li class="js-tab"><a class="box mx-4">Activiteiten</a></li>
            {% endif %}
            {% if related %}
            <li class="js-tab"><a class="box mx-4">Verwante Commissies</a></li>
            {% endif %}
        </ul>
    </div>
{% endblock %}

{% block body %}
    <!-- Tab 1 -->
    <div class="js-tab-content" style="display: block;">
        <div class="columns">
            <div class="column">
                {% if group.description%}
                    <p class="mb-3 has-text-centered">{{group.description}}</p>
                {% endif %}
                <div class="box">
                    <table class="table is-fullwidth is-striped" >
                        <tbody>
                            <tr>
                                <th class="is-capitalized">{{ group.kind|enum_name:group.KIND_NL }}{% trans "-informatie" %}</th>
                            </tr>
                            <tr>
                                {% if group.email %}
                                    <td>{% trans "Email: " %}{{ group.email }}</td>
                                {% endif %}
                            </tr>
                            <tr>
                                {% if group.website %}
                                    <td>{% trans "Website: " %}<a href={{ group.website }}> {{ group.website }} </a></td>
                                {% endif %}
                            </tr>
                            <tr>
                                <td>{% trans "Opgericht: " %}{{ group.since }}</td>
                            </tr>
                            <tr>
                                {% if group.until %}
                                    <td>{% trans "Opgeheven: " %}{{ group.until }}</td>
                                {% endif %}
                            </tr>
                            <tr>
                                {% if group.categories %}
                                <td>{% trans "Categorie: " %}{% group_category_link group.categories %}</td>
                                {% endif %}
                            </tr>
                        </tbody>
                    </table>
                </div>
                {% if events_upcoming %}    
                    <table class="table">
                        <thead>
                            <tr>
                                <th>
                                    Toekomstige activiteiten
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for event in events_upcoming %}
                                <tr>
                                    <td>
                                        <a href="{% url 'activities:detail' event.activity.id %}#event-{{ event.pk }}">
                                            {{ event }}
                                        </a>
                                        <span>
                                            ({{ event.time_start }} - {{ event.time_end }})
                                        </span>
                                    </td>
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% endif %}
            </div>
            <div class="column is-two-fifths">
                <img class="group-poster" src="{{ group.get_poster_url }}">
            </div>
        </div>
    </div>

    <!-- Tab 2 -->
    <div class="js-tab-content" style="display: none;">
        {% if group.groupmembership_set.all %}
        <div class="title">{% trans "Huidige leden" %}</div>
            <table class="table is-fullwidth">
                <thead>
                    <tr>
                        <th>{% trans "Commissielid:" %}</th>
                        <th>{% trans "Begindatum:" %} </th>
                        <th>{% trans "Functie:" %}</th>
                        <th>{% trans "Spreuk:" %} </th>
                    </tr>
                </thead>
                <tbody>
                    {% if members_current %}
                        {% for member in members_current %}
                            <tr>
                                <td>{% group_member_link member %}</td>
                                <td>{{ member.since }}</td>
                                <td> </td>
                                <td> </td>
                            </tr>
                        {% endfor %}
                    {% endif %}
                </tbody>
            </table>
        {% endif %}

        <div class="title">{% trans "Oud-leden" %}</div>
        <table class="table is-fullwidth">
            <thead>
                <tr>
                    <th>{% trans "Commissielid:" %}</th>
                    <th>{% trans "Begindatum:" %}</th>
                    <th>{% trans "Einddatum:" %}</th>
                    <th>{% trans "Functie:" %}</th>
                    <th>{% trans "Spreuk:" %} </th>
                </tr>
            </thead>
            <tbody>
                {% if members_past %}
                    {% for member in members_past %}   
                        <tr>
                            <td>{% group_member_link member %}</td>
                            <td>{{ member.since }}</td>
                            <td>{{ member.until }}</td>
                            <td> </td>
                            <td> </td>
                        </tr> 
                    {% endfor %}
                {% endif %}
            </tbody>
        </table>
    </div>

    <!-- Tab 3 -->
    {% if events_upcoming or events_past %}
        <div class="js-tab-content" style="display: none;">
            <div class="columns">
                <table class="column table">
                    <thead>
                        <tr>
                            <th class="title">
                                Activiteiten
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for event in events_upcoming %}
                            <tr>
                                <td>
                                    <span>
                                        {{ event.time_start|date:"d M 'y" }}
                                    </span>
                                    <a href="{% url 'activities:detail' event.activity.id %}#event-{{ event.pk }}">
                                        {{ event }}
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>

                <table class="column table">
                    <thead>
                        <tr>
                            <th class="title">
                                Oude activiteiten
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for event in events_past %}
                            <tr>
                                <td>
                                    <span>
                                        {{ event.time_start|date:"d M 'y" }}
                                    </span>
                                    <a href="{% url 'activities:detail' event.activity.id %}#event-{{ event.pk }}">
                                        {{ event }}
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table> 
            </div>       
        </div>
    {% endif %}

    <!-- Tab 4 -->
    {% if related %}
        <div class="js-tab-content" style="display: none;">
            <table class="table">
                <thead>
                    <tr>
                        <th class="title">
                            Verwante Commissies
                        </th>
                    </tr>
                </thead>
                <tbody>
                    {% for group in related %}
                        <tr>
                            <td>  
                                {% group_link group %}
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        </div>
    {% endif %}

{% endblock %}

{% block scripts_postload %}

<script>
    addTabEventListeners();
</script>

{{ block.super }}

{% endblock %}

groups/templates/groups/group_list.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}

{% block title %}
Commissies, groepen en disputen
{% endblock %}

{% block banner %}
    <h1 class="title">{% trans "Commissies, groepen en disputen" %}</h1>
    <div class="box"> 
    Hieronder vind je een overzicht van commissies, disputen en groepen binnen A–Eskwadraat die op dit moment bezig zijn met het organiseren van activiteiten en andere bezigheden in naam van de vereniging. 
    Naast deze commissies zijn er door het jaar heen ook andere soorten commissies en groepen die bezig zijn. 
    Voor een overzicht over alle commissies binnen A–Eskwadraat, kun je het <a href="https://www.a-eskwadraat.nl/Vereniging/Commissies/Boekje/commissieboekje_2019.pdf">commissieboekje</a> raadplegen. 
    Op de <a href="/Vereniging/Commissies/Vacatures">vacaturepagina</a> staat een aantal commissies die op zoek zijn naar leden.  
    Heb je interesse in een commissie? Stuur dan een mailtje naar actief@a-eskwadraat.nl!
    </div>
{% endblock %}

{% block body %}
    <h3 class="is-size-4 mb-5 groups-headlines" >{% trans "Commissies" %}</h3>
    <div class="mb-5">
        {% if committees %}
            <ul class="is-flex is-flex-wrap-wrap">
                {% for committee in committees %}
                    <li class="groups-block">
                        <img src="{{ committee.get_poster_url }}"><br>
                        <a href="{% url 'groups:group_detail' committee.id %}">{{committee}}</a><br>
                        <div class="group-block-text">   
                            {% if committee.description%}
                                <h> {{committee.description}} </h>
                            {% endif %}
                            <a class="mb-1 mr-1" href="{% if committee.website %} {{ committee.website }} {% else %} {% url 'groups:group_detail' committee.id %} {% endif %}">
                                <span class="fa fa-globe fa-2x" title="Website"></span>
                            </a>
                        </div>
                    </li>
                {% endfor %}
            </ul>
        {% else %}
            <p>Er zijn geen commissies.</p>
        {% endif %}
    </div>
    <h3 class="is-size-4 mb-5 groups-headlines">{% trans "Groepen" %}</h3>
    <div class="mb-5">
        {% if groups %}
            <ul class="is-flex is-flex-wrap-wrap">
                {% for group in groups %}
                    <li class="groups-block">
                        <img src="{{ group.get_poster_url }}"><br>
                        <a href="{% url 'groups:group_detail' group.id %}">{{group}}</a><br>
                        <div class="group-block-text">   
                            {% if group.description%}
                                <h> {{group.description}} </h>
                            {% endif %}
                            <a class="mb-1 mr-1" href="{% if group.website %} {{ group.website }} {% else %} {% url 'groups:group_detail' group.id %} {% endif %}">
                                <span class="fa fa-globe fa-2x" title="Website"></span>
                            </a>
                        </div>
                    </li>
                {% endfor %}
            </ul>
        {% else %}
            <p>Er zijn geen groepen.</p>
        {% endif %}
    </div>
    <h3 class="is-size-4 mb-5 groups-headlines">{% trans "Disputen" %}</h3>
    <div class="mb-5">
        {% if societies %}
            <ul class="is-flex is-flex-wrap-wrap">
                {% for society in societies %}
                    <li class="groups-block">
                        <img src="{{ society.get_poster_url }}"><br>
                        <a href="{% url 'groups:group_detail' society.id %}">{{society}}</a><br>
                        <div class="group-block-text">   
                            {% if society.description%}
                                <h> {{society.description}} </h>
                            {% endif %}
                            <a class="mb-1 mr-1" href="{% if society.website %} {{ society.website }} {% else %} {% url 'groups:group_detail' society.id %} {% endif %}">
                                <span class="fa fa-globe fa-2x" title="Website"></span>
                            </a>
                        </div>
                    </li>
                {% endfor %}
            </ul>
        {% else %}
            <p>Er zijn geen disputen.</p>
        {% endif %}
    </div>
{% endblock %}

groups/templates/groups/member_detail.html
{% extends "base.html" %}
{% load i18n %}

{% block body %}
<h1>{% trans "Groeplidmaatschap" %}</h1>
<p>{% trans "Lid: " %}{% person_link groupmembership.person %}</p>
<p>{% trans "Groep: " %}{% group_link groupmembership.group %}</p>
<p>{% trans "Begin: " %}{{ groupmembership.since }}</p>
{% if groupmembership.until %}
<p>{% trans "Einde: " %}{{ groupmembership.until }}</p>
{% endif %}
{% endblock %}